using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace SoundDemo
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        SoundEffect soundEffect;
        SoundEffectInstance soundEffectInstance;

        Song mySong;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
            this.IsMouseVisible = true;
        }

        protected override void Initialize()
        {
            base.Initialize();
        }

        protected override void LoadContent()
        {            
            spriteBatch = new SpriteBatch(GraphicsDevice);

            mySong = Content.Load<Song>(@"213238_OH_YEAHHH");
            soundEffect = Content.Load<SoundEffect>(@"zap");            
        }

        protected override void UnloadContent()
        {
            // NOP
        }

        protected override void Update(GameTime gameTime)
        {            
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();

            // P starts background music playing
            if (Keyboard.GetState().IsKeyDown(Keys.P))
            {
                MediaPlayer.Play(mySong);
            }

            // S pauses the music playback
            if (Keyboard.GetState().IsKeyDown(Keys.S))
            {
                MediaPlayer.Pause();
            }

            // R resumes playing music
            if (Keyboard.GetState().IsKeyDown(Keys.R))
            {
                MediaPlayer.Resume();
            }            

            // Space plays the sound effect (laser zap)
            if (Keyboard.GetState().IsKeyDown(Keys.Space))
            {
                soundEffectInstance = soundEffect.CreateInstance();
                soundEffectInstance.Play();
            }

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);
            base.Draw(gameTime);
        }
    }
}
