using System;
using System.Collections.Generic;
using System.Linq;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Media;

namespace XactDemo
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        AudioEngine audioEngine;
        WaveBank waveBank;
        SoundBank soundBank;
        Cue stompAndSnare;

        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            Content.RootDirectory = "Content";
        }

        protected override void Initialize()
        {
            base.Initialize();
        }

        protected override void LoadContent()
        {
            spriteBatch = new SpriteBatch(GraphicsDevice);

            audioEngine = new AudioEngine(@"Content\XactDemo.xgs");
            waveBank = new WaveBank(audioEngine, @"Content\WaveBank1.xwb");
            soundBank = new SoundBank(audioEngine, @"Content\SoundBank1.xsb");
            stompAndSnare = soundBank.GetCue("stomp_and_snare");
        }

        protected override void UnloadContent()
        {
            // NOP
        }

        protected override void Update(GameTime gameTime)
        {
            if (GamePad.GetState(PlayerIndex.One).Buttons.Back == ButtonState.Pressed)
                this.Exit();
            
            if (Keyboard.GetState().IsKeyDown(Keys.Space))
            {
                if (!stompAndSnare.IsPlaying)
                {
                    stompAndSnare = soundBank.GetCue("stomp_and_snare");
                    stompAndSnare.Play();
                }                
            }
            audioEngine.Update();

            base.Update(gameTime);
        }

        protected override void Draw(GameTime gameTime)
        {
            GraphicsDevice.Clear(Color.CornflowerBlue);

            base.Draw(gameTime);
        }
    }
}
